25'ten fazla konu seçemezsiniz Konular bir harf veya rakamla başlamalı, kısa çizgiler ('-') içerebilir ve en fazla 35 karakter uzunluğunda olabilir.
 
 
 
 
 
 

812 satır
18 KiB

  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. if echo $PATH | grep "$HOME" >/dev/null 2>&1
  39. then
  40. PATH="${PATH}:${HOME}/.local/bin"
  41. fi
  42. if false iswindows
  43. then
  44. export PAGER='tr -d \\r | less'
  45. else
  46. export PAGER="less"
  47. fi
  48. export LESS="-iRMX"
  49. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  50. if test -n "$_src_hilite_lp_path"
  51. then
  52. export LESSOPEN="| $_src_hilite_lp_path %s"
  53. fi
  54. if null type vim
  55. then
  56. export EDITOR=vim
  57. else
  58. export EDITOR=vi
  59. fi
  60. export LANG=ja_JP.UTF-8
  61. export LC_MESSAGES=C
  62. # export CDPATH=".:~"
  63. export VISUAL="$EDITOR"
  64. export GIT_PAGER="less -F"
  65. export GIT_EDITOR="$EDITOR"
  66. if test -n "$TMUX" && \
  67. echo $TERM | grep screen >/dev/null 2>&1 && \
  68. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  69. then
  70. TERM=screen-256color
  71. fi
  72. test -z "$TMP" && export TMP=/tmp/${USER}-tmp
  73. mkdir -p "$TMP"
  74. ! iswindows && null type stty && {
  75. stty stop undef # unbind C-s to stop displaying output
  76. # stty erase '^h'
  77. }
  78. if iswindows; then
  79. export USER=$USERNAME
  80. fi
  81. _tmux_prefs(){
  82. null type tmux || return 1
  83. tmux set -g mode-keys vi
  84. }
  85. if test -d ~/dbx
  86. then
  87. export CHIT_PATH="$HOME/dbx/.chit"
  88. fi
  89. #######################
  90. iswindows && alias tty="echo cmd.exe"
  91. type fortune >/dev/null 2>&1 && {
  92. fortune
  93. echo
  94. fortune -o
  95. echo
  96. }
  97. uname -a
  98. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  99. running $BASH $BASH_VERSION
  100. if test -n "$TMUX"
  101. then
  102. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  103. 2>/dev/null
  104. echo
  105. fi
  106. ###################################
  107. # some aliases and functions
  108. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  109. _coloroption=" --color=auto"
  110. ( ! with_coreutils && isdarwin ) || iswindows || \
  111. _timeoption=" --time-style=long-iso"
  112. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  113. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  114. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  115. _timeformat_num="%Y%m%d%H%M%S"
  116. alias datenum="date +$_timeformat_num"
  117. alias ls="ls -hCF${_coloroption}${_timeoption}"
  118. if ! with_coreutils
  119. then
  120. export LSCOLORS=gxfxcxdxbxegedabagacad
  121. alias ls="ls -G"
  122. fi
  123. # export GREP_OPTIONS=""
  124. alias gr="grep -n --color=always"
  125. iswindows && alias grep="grep -n"
  126. # alias ll="ls -l"
  127. # alias la="ls -A"
  128. # alias lla="ls -Al"
  129. alias less="less -F"
  130. null type emacs && alias em="emacs -nw"
  131. null type vim && alias vi=vim
  132. alias pstree="LANG=C pstree"
  133. alias cp="cp -v"
  134. alias mv="mv -v"
  135. alias rm="rm -v"
  136. alias psaux="ps auxww"
  137. alias q=exit
  138. null type e3em && alias e3=e3em
  139. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  140. alias po=popd
  141. alias pu=pushd
  142. null type sudo && alias sudo="sudo " # use aliases through sudo
  143. null type sudoedit && alias sudoe="sudoedit"
  144. null type halt && alias halt="sudo halt"
  145. null type reboot && alias reboot="sudo reboot"
  146. null type dbus-send && {
  147. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  148. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  149. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  150. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  151. }
  152. alias rand="echo \$RANDOM"
  153. null type file-roller && alias xunp="file-roller -h"
  154. null type paco && alias pc="sudo \paco -D"
  155. alias pycalc="python -i -c 'from math import *' "
  156. null type python3 && alias py3=python3
  157. null type python2 && alias py2=python2
  158. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  159. # alias mytime="date +%Y%m%d-%H%M%S"
  160. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  161. # type trash >/dev/null 2>&1 && alias rm=trash
  162. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  163. null type xmms2 && alias xm="xmms2"
  164. #export PLAYER="mpg123 -C -v --title"
  165. null type screen && alias screen="screen -e^z^z"
  166. #alias zcd="cd \`zenity --file-selection --directory\`"
  167. null type gtags && alias gtags="gtags --verbose"
  168. null type htags && alias htags="htags --xhtml --symbol --line-number \
  169. --frame --alphabet --verbose"
  170. null type aunpack && alias au=aunpack
  171. null type lv && alias lv="lv|less"
  172. isdarwin && alias updatedb="LC_ALL=C updatedb"
  173. # do not use locate installed by macports
  174. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  175. # pad
  176. alias pad=notepad
  177. null type gedit && alias pad=gedit
  178. null type leafpad && alias pad=leafpad
  179. isdarwin && alias pad="open -e"
  180. null type wicd-curses && alias wic=wicd-curses
  181. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  182. #alias wicn="wicd-cli -y -c -n"
  183. wicn(){
  184. if test $# -eq 0
  185. then
  186. local num
  187. wicd-cli -y -l | head
  188. echo -n "input num: "
  189. read num
  190. test -n "$num" && wicd-cli -y -c -n $num
  191. else
  192. wicd-cli -y -c -n $1
  193. fi
  194. }
  195. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  196. /usr/share/vim/vim73/macros/less.sh \
  197. /usr/share/vim/vim72/macros/less.sh
  198. do
  199. test -f $f && alias vl=$f && break
  200. done
  201. null type yaourt && alias yt=yaourt
  202. null type cower && alias cower="cower --color=auto"
  203. null type pacmatic && {
  204. alias pacman="pacmatic"
  205. export PACMAN="pacmatic"
  206. }
  207. _pacman_update_mirrorlist_with_reflector(){
  208. ml=/etc/pacman.d/mirrorlist
  209. cmd="$(expr "$(grep reflector $ml)" : '# With: *\(.*\)')"
  210. if test -z "$cmd"
  211. then
  212. cmd="reflector --verbose -l 5 --sort rate --save /etc/pacman.d/mirrorlist"
  213. fi
  214. sudo $cmd
  215. }
  216. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  217. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  218. null type apt-get && {
  219. alias aupgrade="sudo apt-get autoremove --yes && \
  220. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  221. alias aptin="apt-get install"
  222. alias aptsearch="apt-cache search"
  223. alias aptshow="apt-cache show"
  224. }
  225. null type port && {
  226. alias port="port -v"
  227. alias pupgrade="sudo port -v selfupdate && \
  228. { sudo port -v upgrade outdated; }"
  229. }
  230. if iscygwin; then
  231. null type windate || \
  232. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  233. # alias cygsu="cygstart /cygwinsetup.exe"
  234. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  235. fi
  236. g(){
  237. if test $# -eq 0 && null type git-info
  238. then
  239. git info
  240. else
  241. git "$@"
  242. fi
  243. }
  244. if null type _git && inbash
  245. then
  246. # enable programmable completion for g
  247. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  248. || complete -o default -o nospace -F _git g
  249. fi
  250. null type gitmemo && alias m=gitmemo
  251. null type gitmemo && alias m=gitmemo
  252. alias setup.py="sudo python3 setup.py install --record files.txt"
  253. ssh(){
  254. __my_set_screen_title ssh
  255. command ssh "$@"
  256. }
  257. clk(){
  258. local tformat="%Y/%m/%d %H:%M:%S %z"
  259. cal
  260. REPLY=
  261. printf "\\r`date "+${tformat}"`"
  262. read -t 1
  263. while test $? -ne 0
  264. do
  265. printf "\\r`date "+${tformat}"`"
  266. read -t 1
  267. done
  268. }
  269. s(){
  270. if test $# -eq 0
  271. then
  272. echo "No search word given." 1>&2
  273. return 1
  274. fi
  275. if git rev-parse --git-dir >/dev/null 2>&1
  276. then
  277. git grep -n "$@"
  278. elif which ag >/dev/null 2>&1
  279. then
  280. ag --pager="$PAGER" "$@"
  281. elif which ack >/dev/null 2>&1
  282. then
  283. ack --pager="$PAGER" "$@"
  284. else
  285. grep -nH --exclude='.svn/*' --exclude='.git/*' "$@" -r . | $PAGER
  286. # echo "No search command found. Use grep." 2>&1
  287. # return 127
  288. fi
  289. }
  290. man(){
  291. env \
  292. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  293. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  294. LESS_TERMCAP_me=$(printf "\e[0m") \
  295. LESS_TERMCAP_se=$(printf "\e[0m") \
  296. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  297. LESS_TERMCAP_ue=$(printf "\e[0m") \
  298. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  299. man "$@"
  300. }
  301. scr(){
  302. test -n "$1" && pf="${1}-"
  303. local _tformat="%Y%m%d-%H%M%S%z"
  304. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  305. SCRIPT=${_file} script ${_file} "$@"
  306. }
  307. netwait(){
  308. while ! ping -c 1 -t 1 example.com
  309. do
  310. true
  311. done
  312. echo network works.
  313. }
  314. cd(){
  315. if test $# -eq 0
  316. then
  317. pushd ~/ >/dev/null
  318. elif test "$1" = -
  319. then
  320. local pwd="$PWD"
  321. command cd "$OLDPWD"
  322. pushd -n "$pwd" >/dev/null # stack last dir
  323. elif ! test -d "$1"
  324. then
  325. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  326. return 1
  327. else
  328. pushd "$1" >/dev/null
  329. fi
  330. __dirs_rm_dup "$PWD"
  331. echo "$PWD"
  332. }
  333. __dirs_rm_dup(){
  334. for d in "$@"
  335. do
  336. local next="$(__realpath --strip "$d")"
  337. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  338. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  339. do
  340. popd +$l -n >/dev/null
  341. done
  342. done
  343. }
  344. __realpath(){
  345. if type realpath >/dev/null 2>&1
  346. then
  347. command realpath "$@"
  348. else
  349. while ! test -d $1
  350. do
  351. shift
  352. done
  353. local d="$OLDPWD"
  354. command cd "$1"
  355. echo "$PWD"
  356. command cd "$d"
  357. fi
  358. }
  359. dh(){
  360. if test $# -eq 0
  361. then
  362. dirs -v -l
  363. else
  364. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  365. cd "$dir"
  366. fi
  367. }
  368. input(){
  369. local foo
  370. stty -echo
  371. read foo
  372. stty echo
  373. echo $foo
  374. }
  375. tmux(){
  376. if test $# -eq 0
  377. then
  378. (cd ~; command tmux start;)
  379. if command tmux has -t main
  380. then
  381. command tmux attach -t main
  382. else
  383. (cd ~; command tmux new -s main;)
  384. fi
  385. else
  386. command tmux "$@"
  387. fi
  388. }
  389. mcrypt-stream(){
  390. test $# -eq 2 || return 1
  391. case $1 in
  392. en)
  393. mcrypt --key $2 | base64 ;;
  394. de)
  395. base64 -d | mcrypt -d --key $2 ;;
  396. esac
  397. }
  398. gpg-stream(){
  399. test $# -eq 2 || return 1
  400. case $1 in
  401. en)
  402. gpg --passphrase $2 -c --batch |base64 ;;
  403. de)
  404. base64 -d|gpg --passphrase $2 -d --batch ;;
  405. esac
  406. }
  407. dgpg(){
  408. if test "$1" = help || test -z "$2"
  409. then
  410. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  411. return
  412. fi
  413. local srcs="$2"
  414. local dsts="$3"
  415. test -z "$dsts" && dsts="${srcs}.out"
  416. local pw
  417. echo -n "dgpg pw: "
  418. read -s pw
  419. echo ""
  420. test -z "$pw" && return 1
  421. for f in *${srcs}
  422. do
  423. local d="$(basename "$f" "${srcs}")${dsts}"
  424. echo -n "Processing $f to $d..."
  425. if test -d "$f"
  426. then
  427. echo "`printf 'failed (%s is directory)' $f`"
  428. elif test -f "$d"
  429. then
  430. echo "`printf 'failed (%s is already exists)' $d`"
  431. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  432. then
  433. echo "done"
  434. else
  435. echo "failed"
  436. test -f "$d" && rm "$d"
  437. fi
  438. done
  439. }
  440. alias enst="gpg-stream en"
  441. alias dest="gpg-stream de"
  442. showinfo(){
  443. echo "Japanese letters are 表示可能"
  444. __try_exec diskinfo
  445. ! isdarwin && test -n "${DISPLAY}" && {
  446. __try_exec xrandr | \grep --color=never ^Screen
  447. }
  448. iswindows || __try_exec finger $USER
  449. LANG=C __try_exec id
  450. __try_exec xset q
  451. }
  452. x(){
  453. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  454. #mkdir -p ~/.my/log
  455. # nohup startx >~/.my/log/xorg.log 2>&1 &
  456. # exit
  457. exec startx
  458. else
  459. echo "X cant be started! Another X is already running?" 1>&2
  460. fi
  461. }
  462. bak(){
  463. for file in "$@"
  464. do
  465. cp -v ${file} ${file}.bak
  466. done
  467. }
  468. di(){
  469. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  470. then
  471. local diffcmd=colordiff
  472. else
  473. local diffcmd=diff
  474. fi
  475. ${diffcmd} -u "$@" | ${PAGER}
  476. }
  477. tb(){
  478. local tb="$HOME/.my/tb"
  479. mkdir -p "$tb"
  480. for file in "$@"
  481. do
  482. mv -t "$tb" "$file"
  483. done
  484. }
  485. mkcd(){
  486. if test -d "$1"
  487. then
  488. echo "Dir \"$1\" already exists."
  489. else
  490. mkdir -p "$1"
  491. echo "Dir \"$1\" created."
  492. fi
  493. cd "$1"
  494. }
  495. if test -n "$TMUX" && null type reattach-to-user-namespace
  496. then
  497. alias pbpaste="reattach-to-user-namespace pbpaste"
  498. alias pbcopy="reattach-to-user-namespace pbcopy"
  499. fi
  500. catclip(){
  501. if iswindows
  502. then
  503. cat /dev/clipboard | tr -d \\r
  504. elif isdarwin
  505. then
  506. pbpaste
  507. else
  508. xclip -o -selection "clipboard"
  509. fi
  510. }
  511. setclip(){
  512. if test $# -eq 0
  513. then
  514. exec 3<&0
  515. else
  516. exec 3<<__EOF__
  517. `cat "$@"`
  518. __EOF__
  519. fi
  520. if iswindows
  521. then
  522. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  523. elif isdarwin
  524. then
  525. pbcopy 0<&3
  526. else
  527. 0<&3 xclip -i -f -selection "primary" | \
  528. xclip -i -f -selection "clipboard"
  529. fi
  530. exec 3<&-
  531. }
  532. open_file(){
  533. if iswindows
  534. then
  535. cmd.exe //c start "" "$@"
  536. elif isdarwin
  537. then
  538. touch "$@"
  539. open "$@"
  540. elif islinux
  541. then
  542. touch "$@"
  543. if null type pcmanfm; then
  544. LC_MESSAGES= pcmanfm "$@"
  545. else
  546. LC_MESSAGES= xdg-open "$@" &
  547. fi
  548. else
  549. cat "$@"
  550. fi
  551. }
  552. o(){
  553. if test $# -eq 0
  554. then
  555. open_file .
  556. else
  557. for f in "$@"
  558. do
  559. open_file "$(realpath "$f")"
  560. done
  561. fi
  562. }
  563. convmv-sjis2utf8-test(){
  564. convmv -r -f sjis -t utf8 *
  565. }
  566. convmv-sjis2utf8-notest(){
  567. convmv -r -f sjis -t utf8 * --notest
  568. }
  569. winln(){
  570. # for windose make link (actually junction)
  571. if test $# -eq 0
  572. then
  573. {
  574. echo "usage: winln TARGET LINK_NAME"
  575. echo "Create a link to TARGET with the name LINK_NAME \
  576. (that is, TARGET must already exist)."
  577. echo "About other features run 'junction'."
  578. } 1>&2
  579. return 1
  580. else
  581. junction "$2" "$1"
  582. fi
  583. }
  584. __my_moc_state(){
  585. type mocp >/dev/null 2>&1 || return
  586. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  587. printf "$1" "`mocp -Q %title 2>/dev/null`"
  588. }
  589. __my_parse_svn_branch() {
  590. local LANG=C
  591. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  592. local svn_repository_root=$(svn info 2>/dev/null | \
  593. sed -ne 's#^Repository Root: ##p')
  594. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  595. awk '{print $1}'
  596. }
  597. __my_svn_ps1(){
  598. if svn status >/dev/null 2>&1
  599. then
  600. local svn_branch=$(__my_parse_svn_branch)
  601. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  602. fi
  603. }
  604. __my_battery_status(){
  605. local dir=/sys/class/power_supply/BAT0
  606. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  607. test -r $dir/charge_now
  608. then
  609. local st=$(cat $dir/status)
  610. local full=$(cat $dir/charge_full)
  611. local now=$(cat $dir/charge_now)
  612. local rate=$(expr $now \* 100 / $full)
  613. printf "$1" "${st}:${rate}%"
  614. fi
  615. }
  616. alias bat='__my_battery_status %s\\n'
  617. ip-address(){
  618. type ip >/dev/null 2>&1 || return 1
  619. local ip=$(LANG=C ip addr show scope global | \
  620. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  621. test -n "$ip" && printf $1 $ip
  622. }
  623. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  624. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  625. __my_ps1_scale(){
  626. local last=$?
  627. printf "${LINES}x${COLUMNS}"
  628. return $last
  629. }
  630. __my_ps1_tmux(){
  631. local last=$?
  632. null type tmux || return $last
  633. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  634. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  635. return $last
  636. }
  637. __my_ps1_moc(){
  638. local last=$?
  639. __my_moc_state "[MOC:%s]"
  640. return $last
  641. }
  642. for f in /usr/share/git/git-prompt.sh \
  643. /opt/local/share/git-core/git-prompt.sh \
  644. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  645. do
  646. test -r $f && . $f && break
  647. done
  648. GIT_PS1_SHOWDIRTYSTATE=t
  649. GIT_PS1_SHOWUPSTREAM=t
  650. __my_ps1_git(){
  651. local last=$?
  652. null type __git_ps1 || return $last
  653. null __gitdir || return $last
  654. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  655. return $last
  656. }
  657. __my_ps1_ipaddr(){
  658. local last=$?
  659. ! iswindows && ip-address [Addr:%s]
  660. return $last
  661. }
  662. __my_ps1_bttry(){
  663. local last=$?
  664. local bst="${TMP}/batterystatus"
  665. if test -z "$DISPLAY" && ! iswindows
  666. then
  667. test -f $bst && local bstr="$(cat $bst)"
  668. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  669. echo "[Battery:$bstr]"
  670. __my_battery_status %s >$bst &
  671. fi
  672. return $last
  673. }
  674. __my_ps1_dirs(){
  675. dirs | wc -l
  676. }
  677. __my_ps1_jobs(){
  678. jobs | wc -l
  679. }
  680. if test "$TERM" != dumb
  681. then
  682. __my_c1="\[\e[0;33m\]" # color for PWD
  683. __my_c2="\[\e[0;36m\]" # color for user
  684. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  685. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  686. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  687. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  688. else __my_c4="\[\e[1;32m\]" # color for ::
  689. fi
  690. __my_c5="\[\e[30;47m\]" # color for SCR
  691. __my_cdef="\[\e[0m\]"
  692. fi
  693. export _LAST_STATUS=$?
  694. __my_export_last_status(){
  695. export _LAST_STATUS=$?
  696. echo $_LAST_STATUS
  697. return $_LAST_STATUS
  698. }
  699. _ps1_bash="\
  700. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  701. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  702. inbash && PS1=$_ps1_bash
  703. __my_set_screen_title(){
  704. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  705. then
  706. echo -ne "\033k$1\033\\"
  707. fi
  708. }
  709. __my_set_title(){
  710. case $TERM in
  711. (rxvt*|xterm*|aterm|screen*)
  712. title="$(echo $@)"
  713. test -t 1 &&
  714. test -n "$DISPLAY" &&
  715. test -z "$EMACS" &&
  716. echo -n -e "\033]0;${title}\007"
  717. ;;
  718. esac
  719. }
  720. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  721. __my_set_screen_title \$(basename \"\$PWD\")/"